%global _moduledir /%{_lib}/security

Summary:	The oVirt Guest Agent
Name:		ovirt-guest-agent
Version:	1.0.13
Release:	4
License:	ASL 2.0
Group:		Emulators
Url:		http://wiki.ovirt.org/wiki/Category:Ovirt_guest_agent
Source0:	http://evilissimo.fedorapeople.org/releases/ovirt-guest-agent/%{version}/%{name}-%{version}.tar.bz2
Patch0:		ovirt-guest-agent-1.0.13-service-chown.patch
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(python)
BuildRequires:	pkgconfig(systemd)

%description
This is the oVirt management agent running inside the guest. The agent
interfaces with the oVirt manager, supplying heart-beat info as well as
run-time data from within the guest itself. The agent also accepts
control commands to be run executed within the OS (like: shutdown and
restart).

#----------------------------------------------------------------------------

# The ovirt-guest-agent main package is empty.
# This has been done to avoid content duplication. The common package provides
# the content for the main package to work around the issue with the other
# subpackages. You cannot have a noarch main package and arch specific
# subpackages.
%package common
Summary:	Commonly used files of the oVirt Guest Agent
Requires:	python-dbus
Requires:	python-ethtool
Requires:	python-rpm
Requires:	usermode
Requires:	usermode-consoleonly
Provides:	%{name} = %{EVRD}
Requires(pre):	glibc
Requires(pre):	shadow-utils
Requires(post,preun,postun):	systemd
Requires(post,postun):	udev
BuildArch:	noarch

%description common
This is the oVirt management agent running inside the guest. The agent
interfaces with the oVirt manager, supplying heart-beat info as well as
run-time data from within the guest itself. The agent also accepts
control commands to be run executed within the OS (like: shutdown and
restart).

%files common
%doc AUTHORS COPYING NEWS README
%dir %attr (755,ovirtagent,ovirtagent) %{_localstatedir}/log/ovirt-guest-agent
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/after_migration
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation
%dir %attr (755,root,root) %{_sysconfdir}/ovirt-guest-agent/hooks.d/after_hibernation
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/after_migration
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation
%dir %attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/after_hibernation
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent.conf
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-locksession
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-shutdown
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-hibernate
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-logout
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-flush-caches
%config(noreplace) %{_sysconfdir}/pam.d/ovirt-container-list
%config(noreplace) %attr (644,root,root) %{_udevrulesdir}/55-ovirt-guest-agent.rules
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/org.ovirt.vdsm.Credentials.conf
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-locksession
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-shutdown
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-hibernate
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-logout
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-container-list
%config(noreplace) %{_sysconfdir}/security/console.apps/ovirt-flush-caches
%config(noreplace) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_hibernation/55_flush-caches
%config(noreplace) %{_datadir}/ovirt-guest-agent/scripts/hooks/before_migration/55_flush-caches
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_hibernation/55_flush-caches
%config(noreplace) %{_sysconfdir}/ovirt-guest-agent/hooks.d/before_migration/55_flush-caches
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/ovirt-guest-agent.py*
%{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/55-flush-caches
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/55-flush-caches.consolehelper
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/scripts/hooks/defaults/flush-caches
%attr (644,root,root) %{_datadir}/ovirt-guest-agent/default.conf
%attr (644,root,root) %{_datadir}/ovirt-guest-agent/default-logger.conf
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/diskmapper
%{_datadir}/ovirt-guest-agent/CredServer.py*
%{_datadir}/ovirt-guest-agent/GuestAgentLinux2.py*
%{_datadir}/ovirt-guest-agent/OVirtAgentLogic.py*
%{_datadir}/ovirt-guest-agent/VirtIoChannel.py*
%{_datadir}/ovirt-guest-agent/timezone.py*
%{_datadir}/ovirt-guest-agent/hooks.py*
%{_datadir}/ovirt-guest-agent/ovirt-locksession
%{_datadir}/ovirt-guest-agent/ovirt-shutdown
%{_datadir}/ovirt-guest-agent/ovirt-hibernate
%{_datadir}/ovirt-guest-agent/ovirt-logout
%{_datadir}/ovirt-guest-agent/ovirt-container-list
%{_datadir}/ovirt-guest-agent/ovirt-flush-caches
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/ovirt-osinfo
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/LockActiveSession.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/LogoutActiveUser.py*
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/hibernate
%attr (755,root,root) %{_datadir}/ovirt-guest-agent/container-list
%attr (644,ovirtagent,ovirtagent) %{_localstatedir}/log/ovirt-guest-agent/ovirt-guest-agent.log
%{_unitdir}/ovirt-guest-agent.service

%pre common
getent group ovirtagent >/dev/null || groupadd -r -g 175 ovirtagent
getent passwd ovirtagent > /dev/null || \
    useradd -u 175 -g 175 -o -r ovirtagent \
    -c "oVirt Guest Agent" -d %{_datadir}/ovirt-guest-agent -s /sbin/nologin
exit 0

%post common
udevadm trigger --subsystem-match="virtio-ports" --attr-match="name=com.redhat.rhevm.vdsm"
%systemd_post ovirt-guest-agent.service
systemctl enable ovirt-guest-agent.service ||:

%preun common
if [ "$1" -eq 0 ]
then
    %systemd_preun ovirt-guest-agent.service

    # Send an "uninstalled" notification to vdsm.
    VIRTIO=`grep "^device" %{_sysconfdir}/ovirt-guest-agent.conf | awk '{ print $3; }'`
    if [ -w $VIRTIO ]
    then
        # Non blocking uninstalled notification
        echo -e '{"__name__": "uninstalled"}\n' | dd of=$VIRTIO \
            oflag=nonblock status=noxfer conv=nocreat 1>& /dev/null || :
    fi
fi

%postun common
if [ "$1" -eq 0 ]
then
    # Let udev clear access rights
    udevadm trigger --subsystem-match="virtio-ports" --attr-match="name=com.redhat.rhevm.vdsm"
fi
%systemd_postun_with_restart ovirt-guest-agent.service

#----------------------------------------------------------------------------

%package pam-module
Summary:	PAM module for the oVirt Guest Agent
Requires:	%{name}-common = %{EVRD}
Requires:	pam

%description pam-module
The oVirt PAM module provides the functionality necessary to use the
oVirt automatic log-in system.

%files pam-module
%{_moduledir}/pam_ovirt_cred.so

#----------------------------------------------------------------------------

%package gdm-plugin
Summary:	Files for the GDM plug-in of the oVirt Guest Agent
Requires:	%{name}-common = %{EVRD}
Requires:	%{name}-pam-module = %{EVRD}
Requires:	gdm
Requires:	gnome-shell
BuildArch:	noarch

%description gdm-plugin
Files required for the GDM extension to use the oVirt automatic log-in
system

%files gdm-plugin
%config(noreplace) %{_sysconfdir}/pam.d/gdm-ovirtcred

#----------------------------------------------------------------------------

%package kdm-plugin
Summary:	KDM plug-in for the oVirt Guest Agent
BuildRequires:	kdebase4-workspace-devel
Requires:	%{name} = %{EVRD}
Requires:	%{name}-pam-module = %{EVRD}
Requires:	kdm

%description kdm-plugin
The KDM plug-in provides the functionality necessary to use the
oVirt automatic log-in system.

%files kdm-plugin
%config(noreplace) %{_sysconfdir}/pam.d/kdm-ovirtcred
%attr (755,root,root) %{_libdir}/kde4/kgreet_ovirtcred.so

#----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p1

%build
%configure2_5x \
	--disable-static \
	--enable-securedir=%{_moduledir} \
	--includedir=%{_includedir}/security \
	--without-gdm \
	--with-pam-prefix=%{_sysconfdir}

%make

%install
%makeinstall_std
cp gdm-plugin/gdm-ovirtcred.pam %{buildroot}%{_sysconfdir}/pam.d/gdm-ovirtcred

mkdir -p %{buildroot}%{_udevrulesdir}
mv %{buildroot}%{_sysconfdir}/udev/rules.d/55-ovirt-guest-agent.rules %{buildroot}%{_udevrulesdir}/55-ovirt-guest-agent.rules
touch %{buildroot}%{_localstatedir}/log/ovirt-guest-agent/ovirt-guest-agent.log

%changelog

* Wed Oct 11 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.0.13-4
- (654d055) Force proper owner in systemd service for /var/log/ovirt-guest-agent/ovirt-guest-agent.log


